import java.lang.reflect.Field;

import org.betacraft.Addon;
import org.betacraft.Wrapper;

import sun.misc.Unsafe;

public class GameModeSwitch implements Addon {

	@Override
	public void postInit(Wrapper wrapper) {
		if (wrapper.version.startsWith("inf-2010063")) {
			try {
				for (final Field minecraftField : wrapper.appletClass.getDeclaredFields()) {
					final String name = minecraftField.getType().getName();
					if (name.contains("aw")) {

						// Access the Minecraft instance
						minecraftField.setAccessible(true);
						Object mc = minecraftField.get(wrapper.applet);

						// Begin injecting the chosen gamemode...
						final Class clazz = wrapper.classLoader.loadClass(name);
						for (final Field field1 : clazz.getDeclaredFields()) {
							if (field1.getType().getName().equals("aj")) {
								final Class clazz2 = wrapper.classLoader.loadClass("bt");
								final Class clazz3 = wrapper.classLoader.loadClass("aj");

								Field funsafe = Unsafe.class.getDeclaredField("theUnsafe");
								funsafe.setAccessible(true);
								Unsafe unsafe = (Unsafe) funsafe.get(null);
								Object creativeClass = unsafe.allocateInstance(clazz2);

								// Reproduce the init method which is removed in that version
								Field b = clazz3.getDeclaredField("b"); b.setAccessible(true);
								Field a = clazz3.getDeclaredField("a"); a.setAccessible(true);

								b.set(creativeClass, true);
								a.set(creativeClass, mc);

								field1.set(mc, creativeClass);
								break;
							}
						}
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

		if (wrapper.version.equals("inf-20100627") || wrapper.version.equals("inf-20100629")) {
			try {
				for (final Field minecraftField : wrapper.appletClass.getDeclaredFields()) {
					final String name = minecraftField.getType().getName();
					if (name.contains("at")) {

						// Access the Minecraft instance
						minecraftField.setAccessible(true);
						Object mc = minecraftField.get(wrapper.applet);

						// Begin injecting the chosen gamemode...
						final Class clazz = wrapper.classLoader.loadClass(name);
						for (final Field field1 : clazz.getDeclaredFields()) {
							if (field1.getType().getName().equals("ah")) {
								final Class clazz2 = wrapper.classLoader.loadClass("bq");
								final Class clazz3 = wrapper.classLoader.loadClass("ah");

								Field funsafe = Unsafe.class.getDeclaredField("theUnsafe");
								funsafe.setAccessible(true);
								Unsafe unsafe = (Unsafe) funsafe.get(null);
								Object creativeClass = unsafe.allocateInstance(clazz2);

								// Reproduce the init method which is removed in that version
								Field b = clazz3.getDeclaredField("b"); b.setAccessible(true);
								Field a = clazz3.getDeclaredField("a"); a.setAccessible(true);

								b.set(creativeClass, true);
								a.set(creativeClass, mc);

								field1.set(mc, creativeClass);
								break;
							}
						}
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

		if (wrapper.version.equals("inf-20100624") || wrapper.version.startsWith("inf-20100625")) {
			try {
				for (final Field minecraftField : wrapper.appletClass.getDeclaredFields()) {
					final String name = minecraftField.getType().getName();
					if (name.contains("net.minecraft.client.f")) {

						// Access the Minecraft instance
						minecraftField.setAccessible(true);
						Object mc = minecraftField.get(wrapper.applet);

						// Begin injecting the chosen gamemode...
						final Class clazz = wrapper.classLoader.loadClass(name);
						for (final Field field1 : clazz.getDeclaredFields()) {
							if (field1.getType().getName().equals("net.minecraft.client.d.b")) {
								final Class clazz2 = wrapper.classLoader.loadClass("net.minecraft.client.d.d");
								final Class clazz3 = wrapper.classLoader.loadClass("net.minecraft.client.d.b");

								Field funsafe = Unsafe.class.getDeclaredField("theUnsafe");
								funsafe.setAccessible(true);
								Unsafe unsafe = (Unsafe) funsafe.get(null);
								Object creativeClass = unsafe.allocateInstance(clazz2);

								// Reproduce the init method which is removed in that version
								Field b = clazz3.getDeclaredField("b"); b.setAccessible(true);
								Field a = clazz3.getDeclaredField("a"); a.setAccessible(true);

								b.set(creativeClass, true);
								a.set(creativeClass, mc);

								field1.set(mc, creativeClass);
								break;
							}
						}
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

		if (wrapper.version.equals("in-20100203") || wrapper.version.equals("in-20100207-1") || wrapper.version.equals("in-20100207-2") ||
				wrapper.version.equals("in-20100212-1") || wrapper.version.equals("in-20100212-2") || wrapper.version.equals("in-20100214-1") ||
				wrapper.version.equals("in-20100214-2") || wrapper.version.equals("in-20100218") || wrapper.version.equals("in-20100219") ||
				wrapper.version.equals("in-20100223") || wrapper.version.equals("inf-20100227") || wrapper.version.startsWith("inf-201003")) {
			try {
				for (final Field minecraftField : wrapper.appletClass.getDeclaredFields()) {
					final String name = minecraftField.getType().getName();
					if (name.contains("net.minecraft.client.d")) {

						// Access the Minecraft instance
						minecraftField.setAccessible(true);
						Object mc = minecraftField.get(wrapper.applet);

						// Begin injecting the chosen gamemode...
						final Class clazz = wrapper.classLoader.loadClass(name);
						for (final Field field1 : clazz.getDeclaredFields()) {
							if (field1.getType().getName().equals("net.minecraft.client.d.a")) {
								final Class clazz2 = wrapper.classLoader.loadClass("net.minecraft.client.d.c");
								final Class clazz3 = wrapper.classLoader.loadClass("net.minecraft.client.d.a");

								Field funsafe = Unsafe.class.getDeclaredField("theUnsafe");
								funsafe.setAccessible(true);
								Unsafe unsafe = (Unsafe) funsafe.get(null);
								Object creativeClass = unsafe.allocateInstance(clazz2);

								// Reproduce the init method which is removed in that version
								Field b = clazz3.getDeclaredField("b"); b.setAccessible(true);
								Field a = clazz3.getDeclaredField("a"); a.setAccessible(true);

								b.set(creativeClass, true);
								a.set(creativeClass, mc);

								field1.set(mc, creativeClass);
								break;
							}
						}
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

		if (wrapper.version.startsWith("in-201001") || wrapper.version.startsWith("in-20100201")) {
			try {
				for (final Field minecraftField : wrapper.appletClass.getDeclaredFields()) {
					final String name = minecraftField.getType().getName();
					if (name.contains("net.minecraft.client.d")) {

						// Access the Minecraft instance
						minecraftField.setAccessible(true);
						Object mc = minecraftField.get(wrapper.applet);

						// Begin injecting the chosen gamemode...
						final Class clazz = wrapper.classLoader.loadClass(name);
						for (final Field field1 : clazz.getDeclaredFields()) {
							if (field1.getType().getName().equals("net.minecraft.client.c.a")) {
								final Class clazz2 = wrapper.classLoader.loadClass("net.minecraft.client.c.c");
								final Class clazz3 = wrapper.classLoader.loadClass("net.minecraft.client.c.a");

								Field funsafe = Unsafe.class.getDeclaredField("theUnsafe");
								funsafe.setAccessible(true);
								Unsafe unsafe = (Unsafe) funsafe.get(null);
								Object creativeClass = unsafe.allocateInstance(clazz2);

								// Reproduce the init method which is removed in that version
								Field b = clazz3.getDeclaredField("b"); b.setAccessible(true);
								Field a = clazz3.getDeclaredField("a"); a.setAccessible(true);

								b.set(creativeClass, true);
								a.set(creativeClass, mc);

								field1.set(mc, creativeClass);
								break;
							}
						}
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

		if (wrapper.version.equals("in-20091223-2")) {
			try {
				for (final Field minecraftField : wrapper.appletClass.getDeclaredFields()) {
					final String name = minecraftField.getType().getName();
					if (name.contains("net.minecraft.client.e")) {

						// Access the Minecraft instance
						minecraftField.setAccessible(true);
						Object mc = minecraftField.get(wrapper.applet);

						// Begin injecting the chosen gamemode...
						final Class clazz = wrapper.classLoader.loadClass(name);
						for (final Field field1 : clazz.getDeclaredFields()) {
							if (field1.getType().getName().equals("net.minecraft.client.e.a")) {
								final Class clazz2 = wrapper.classLoader.loadClass("net.minecraft.client.e.b");
								final Class clazz3 = wrapper.classLoader.loadClass("net.minecraft.client.e.a");

								Field funsafe = Unsafe.class.getDeclaredField("theUnsafe");
								funsafe.setAccessible(true);
								Unsafe unsafe = (Unsafe) funsafe.get(null);
								Object survivalClass = unsafe.allocateInstance(clazz2);

								// Reproduce the init method which is removed in c0.28 - creative c0.30s
								Field c = clazz2.getDeclaredField("c"); c.setAccessible(true);
								Field d = clazz2.getDeclaredField("d"); d.setAccessible(true);
								Field e = clazz2.getDeclaredField("e"); e.setAccessible(true);
								Field f = clazz2.getDeclaredField("f"); f.setAccessible(true);
								Field g = clazz2.getDeclaredField("g"); g.setAccessible(true);
								Field h = clazz2.getDeclaredField("h"); h.setAccessible(true);
								Field a = clazz3.getDeclaredField("a"); a.setAccessible(true);

								c.set(survivalClass, -1);
								d.set(survivalClass, -1);
								e.set(survivalClass, -1);
								f.set(survivalClass, 0);
								g.set(survivalClass, 0);
								h.set(survivalClass, 0);
								a.set(survivalClass, mc);

								field1.set(mc, survivalClass);
								break;
							}
						}
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

		if (wrapper.launchType.equals("classicmp")) {
			try {
				for (final Field minecraftField : wrapper.appletClass.getDeclaredFields()) {
					final String name = minecraftField.getType().getName();
					if (name.contains("com.mojang.minecraft.l")) {

						// Set Minecraft field accessible
						minecraftField.setAccessible(true);
						// Get the instance
						Object mc = minecraftField.get(wrapper.applet);

						final Class clazz = wrapper.classLoader.loadClass(name);
						for (final Field field1 : clazz.getDeclaredFields()) {
							if (field1.getType().getName().equals("com.mojang.minecraft.d.b")) {
								final Class clazz2 = wrapper.classLoader.loadClass("com.mojang.minecraft.d.c");
								final Class clazz3 = wrapper.classLoader.loadClass("com.mojang.minecraft.d.b");

								Field funsafe = Unsafe.class.getDeclaredField("theUnsafe");
								funsafe.setAccessible(true);
								Unsafe unsafe = (Unsafe) funsafe.get(null);
								Object survivalClass = unsafe.allocateInstance(clazz2);

								// Reproduce the init method which is removed in c0.28 - creative c0.30s
								Field c = clazz2.getDeclaredField("c"); c.setAccessible(true);
								Field d = clazz2.getDeclaredField("d"); d.setAccessible(true);
								Field e = clazz2.getDeclaredField("e"); e.setAccessible(true);
								Field f = clazz2.getDeclaredField("f"); f.setAccessible(true);
								Field g = clazz2.getDeclaredField("g"); g.setAccessible(true);
								Field h = clazz2.getDeclaredField("h"); h.setAccessible(true);
								Field a = clazz3.getDeclaredField("a"); a.setAccessible(true);

								c.set(survivalClass, -1);
								d.set(survivalClass, -1);
								e.set(survivalClass, -1);
								f.set(survivalClass, 0);
								g.set(survivalClass, 0);
								h.set(survivalClass, 0);
								a.set(survivalClass, mc);

								field1.set(mc, survivalClass);
								break;
							}
						}
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}
	}

	@Override
	public void preInit(Wrapper arg0) {}
}
